;;;; amb-extras.scm
;;;; Kon Lovett, Mar '09

(module amb-extras

(;export
  implies
  (choose shuffle)
  one-of
  all-of
  required
  distinct?)

(import scheme chicken)
(import
  (only srfi-1 member)
  (only extras random)
  (only data-structures sort!))

(import
  amb
  (only type-checks check-list check-procedure))
(require-library
  amb
  type-checks)

;;

(define (implies a b)
  (or (not a) b) )

(define shuffle
  ;; this should really shadow SORT! and RANDOM...
  (lambda (l random)
    (let ((len (length l)))
      (map
        cdr
        (sort!
          (map (lambda (x) (cons (random len) x)) l)
          (lambda (x y) (< (car x) (car y)))) ) ) ) )

(define-syntax choose
  (syntax-rules ()
    ((_ ?ls)
      (amb-thunks (map (lambda (x) (lambda () x)) (shuffle ?ls random))) ) ) )

(define-syntax one-of
  (syntax-rules ()
    ((_ ?expr)
      (amb-find ?expr) ) ) )

(define-syntax all-of
  (syntax-rules ()
    ((_ ?expr)
      (amb-collect ?expr) ) ) )

(define-syntax required
  (syntax-rules ()
    ((_ ?expr)
      (amb-assert ?expr) ) ) )

(define (distinct? xs #!optional (eql? equal?))
  (check-list 'distinct? xs 'list)
  (check-procedure 'distinct? eql? 'equivalence)
  (let loop ((xs xs))
    (or
      (null? xs)
      (and
        (not (member (car xs) (cdr xs) eql?))
        (loop (cdr xs)))) ) )

) ;module amb-extras
